## openswan 2.6.38

=== Makefile ===
# Openswan master makefile
# Copyright (C) 1998-2002  Henry Spencer.
# Copyright (C) 2003-2004  Xelerance Corporation
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.
#

OPENSWANSRCDIR?=$(shell pwd)
export OPENSWANSRCDIR

TERMCAP=
export TERMCAP

include ${OPENSWANSRCDIR}/Makefile.inc

srcdir?=$(shell pwd)

# dummy default rule
def:
	@echo "Please read the README for detailed build instructions including how"
	@echo "to enable NAT-T support for your kernel, if desired"
	@echo
	@echo "Commonly used build commands:"
	@echo
	@echo "When using KLIPS:"
	@echo " make KERNELSRC=/usr/src/linux-2.6.36 module minstall programs install"
	@echo
	@echo "When using KLIPS with OCF:"
	@echo " make KERNELSRC=/usr/src/linux-2.6.36-ocf/ MODULE_DEF_INCLUDE=$${OPENSWANSRCDIR}/packaging/ocf/config-all.hmodules module minstall programs install"
	@echo
	@echo "When using NETKEY:"
	@echo " make programs install"
	@echo
	@echo "When called in openwrt/packaging/openswan/Makefile to build kmod-openswan"
	@echo " make MODULE_DEFCONFIG=$${OPENSWANSRCDIR}/packaging/openwrt/defconfig MODULE_DEF_INCLUDE=$${OPENSWANSRCDIR}/packaging/openwrt/config-all.h module"
	@echo
	@echo
include ${OPENSWANSRCDIR}/Makefile.top

# kernel details
# what variant of our patches should we use, and where is it
KERNELREL=$(shell ${KVSHORTUTIL} ${KERNELSRC}/Makefile)

# directories visited by all recursion

# declaration for make's benefit
.PHONY:	def insert kpatch patches _patches _patches2.4 \
	klipsdefaults programs install clean distclean \
	ogo oldgo menugo xgo \
	omod menumod xmod \
	pcf ocf mcf xcf rcf nopromptgo \
	precheck verset confcheck kernel \
	module module24 module26 kinstall minstall minstall24 minstall26 \
	moduleclean mod24clean module24clean mod26clean module26clean \
	backup unpatch uninstall install_file_list \
	snapready relready ready buildready devready uml check taroldinstall \
	umluserland


kpatch: unapplypatch applypatch klipsdefaults
npatch: unapplynpatch applynpatch
sarefpatch: unapplysarefpatch applysarefpatch

unapplypatch:
	@echo "info: making unapplypatch in `pwd` and KERNELSRC=\"${KERNELSRC}\";"
	-@if [ -f ${KERNELSRC}/openswan.patch ]; then \
		echo Undoing previous patches; \
		cat ${KERNELSRC}/openswan.patch | (cd ${KERNELSRC} && patch -p1 -R --force -E -z .preipsec --reverse --ignore-whitespace ); \
	fi

applypatch:
	@echo "info: Now performing forward patches in `pwd`";
	${MAKE} kernelpatch${KERNELREL} | tee ${KERNELSRC}/openswan.patch | (cd ${KERNELSRC} && patch -p1 -b -z .preipsec --forward --ignore-whitespace )

unapplynpatch:
	@echo "info: making unapplynpatch (note the second N) in `pwd`";
	-@if [ -f ${KERNELSRC}/natt.patch ]; then \
		echo Undoing previous NAT patches; \
		cat ${KERNELSRC}/natt.patch | (cd ${KERNELSRC} && patch -p1 -R --force -E -z .preipsec --reverse --ignore-whitespace ); \
	fi

applynpatch:
	@echo "info: Now performing forward NAT patches in `pwd`"; 
	${MAKE} nattpatch${KERNELREL} | tee ${KERNELSRC}/natt.patch | (cd ${KERNELSRC} && patch -p1 -b -z .preipsec --forward --ignore-whitespace )

unapplysarefpatch:
	@echo "info: making unapplysarefpatch in `pwd`";
	-@if [ -f ${KERNELSRC}/saref.patch ]; then \
		echo Undoing previous saref patches; \
		cat ${KERNELSRC}/saref.patch | (cd ${KERNELSRC} && patch -p1 -R --force -E -z .preng --reverse --ignore-whitespace ); \
	fi

applysarefpatch:
	@echo "info: Now performing SAref patches in `pwd`";
	${MAKE} sarefpatch${KERNELREL} | tee ${KERNELSRC}/klipsng.patch | (cd ${KERNELSRC} && patch -p1 -b -z .preng --forward --ignore-whitespace )

# patch kernel
PATCHER=packaging/utils/patcher

patches:
	@echo \"make patches\" is obsolete. See \"make kpatch\".
	exit 1

_patches:
	echo "===============" >>out.kpatch
	echo "`date` `cd $(KERNELSRC) ; pwd`" >>out.kpatch
	$(MAKE) __patches$(KERNELREL) >>out.kpatch

# Linux-2.4.0 version
PATCHES22=klips/patches2.2
__patches2.3 __patches2.4:
	@$(PATCHER) -v -c $(KERNELSRC) Documentation/Configure.help \
		'CONFIG_KLIPS' $(PATCHES)/Documentation/Configure.help.fs2_2.patch
	@$(PATCHER) -v $(KERNELSRC) net/Config.in \
		'CONFIG_KLIPS' $(PATCHES)/net/Config.in.fs2_4.patch
	@$(PATCHER) -v $(KERNELSRC) net/Makefile \
		'CONFIG_KLIPS' $(PATCHES)/net/Makefile.fs2_4.patch
	@$(PATCHER) -v $(KERNELSRC) net/ipv4/af_inet.c \
		'CONFIG_KLIPS' $(PATCHES)/net/ipv4/af_inet.c.fs2_4.patch
	@$(PATCHER) -v $(KERNELSRC) net/ipv4/udp.c \
		'CONFIG_KLIPS' $(PATCHES)/net/ipv4/udp.c.fs2_4.patch
	@$(PATCHER) -v $(KERNELSRC) include/net/sock.h \
		'CONFIG_KLIPS' $(PATCHES)/include/net/sock.h.fs2_4.patch
# Removed patches, will unpatch automatically.
	@$(PATCHER) -v $(KERNELSRC) include/linux/proc_fs.h
	@$(PATCHER) -v $(KERNELSRC) net/core/dev.c
	@$(PATCHER) -v $(KERNELSRC) net/ipv4/protocol.c
	@$(PATCHER) -v $(KERNELSRC) drivers/net/Space.c
	@$(PATCHER) -v $(KERNELSRC) include/linux/netlink.h
	@$(PATCHER) -v $(KERNELSRC) net/netlink/af_netlink.c
	@$(PATCHER) -v $(KERNELSRC) net/netlink/netlink_dev.c
	@$(PATCHER) -v $(KERNELSRC) drivers/isdn/isdn_net.c

klipsdefaults:
	@KERNELDEFCONFIG=$(KERNELSRC)/arch/$(ARCH)/defconfig ; \
	KERNELCONFIG=$(KCFILE) ; \
	if ! egrep -q 'CONFIG_KLIPS' $$KERNELDEFCONFIG ; \
	then \
		set -x ; \
		cp -a $$KERNELDEFCONFIG $$KERNELDEFCONFIG.orig ; \
		chmod u+w $$KERNELDEFCONFIG ; \
		cat $$KERNELDEFCONFIG $(KERNELKLIPS)/defconfig \
			>$$KERNELDEFCONFIG.tmp ; \
		rm -f $$KERNELDEFCONFIG ; \
		cp -a $$KERNELDEFCONFIG.tmp $$KERNELDEFCONFIG ; \
		rm -f $$KERNELDEFCONFIG.tmp ; \
	fi ; \
	if ! egrep -q 'CONFIG_KLIPS' $$KERNELCONFIG ; \
	then \
		set -x ; \
		cp -a $$KERNELCONFIG $$KERNELCONFIG.orig ; \
		chmod u+w $$KERNELCONFIG ; \
		cat $$KERNELCONFIG $(KERNELKLIPS)/defconfig \
			>$$KERNELCONFIG.tmp ; \
		rm -f $$KERNELCONFIG ; \
		cp -a $$KERNELCONFIG.tmp $$KERNELCONFIG ; \
		rm -f $$KERNELCONFIG.tmp ; \
	fi



# programs

ifeq ($(strip $(OBJDIR)),.) # If OBJDIR is OPENSWANSRCDIR (ie dot) then the simple case:
programs install clean:: 
	@for d in $(SUBDIRS) ; \
	do \
		(cd $$d && $(MAKE) srcdir=${OPENSWANSRCDIR}/$$d/ OPENSWANSRCDIR=${OPENSWANSRCDIR} $@ ) || exit 1; \
	done; 
else
ABSOBJDIR:=$(shell mkdir -p ${OBJDIR}; cd ${OBJDIR} && pwd)
OBJDIRTOP=${ABSOBJDIR}
export OBJDIRTOP

programs install clean:: ${OBJDIR}/Makefile
	@echo OBJDIR: ${OBJDIR}
	(cd ${ABSOBJDIR} && OBJDIRTOP=${ABSOBJDIR} OBJDIR=${ABSOBJDIR} ${MAKE} $@ )

${OBJDIR}/Makefile: ${srcdir}/Makefile packaging/utils/makeshadowdir
	@echo Setting up for OBJDIR=${OBJDIR}
	@packaging/utils/makeshadowdir `(cd ${srcdir}; echo $$PWD)` ${OBJDIR} "${SUBDIRS}"

endif

checkprograms:: 
	@for d in $(SUBDIRS) ; \
	do \
		(cd $$d && $(MAKE) srcdir=${OPENSWANSRCDIR}/$$d/ OPENSWANSRCDIR=${OPENSWANSRCDIR} $@ ) || exit 1; \
	done; 

checkv199install:
	@if [ "${LIBDIR}" != "${LIBEXECDIR}" ] && [ -f ${LIBDIR}/pluto ]; \
	then \
		echo WARNING: Old version of FreeS/WAN Openswan 1.x installed. ;\
		echo WARNING: moving ${LIBDIR} to ${LIBDIR}.v1 ;\
		mv ${LIBDIR} ${LIBDIR}.v1 ;\
	fi

install:: checkv199install

clean::
	rm -rf $(RPMTMPDIR) $(RPMDEST)
	rm -f out.*build out.*install	# but leave out.kpatch

# proxies for major kernel make operations

# do-everything entries
KINSERT_PRE=precheck verset insert
PRE=precheck verset kpatch
POST=confcheck programs kernel install 
MPOST=confcheck programs module install 
#ogo:		$(PRE) pcf $(POST)
#oldgo:		$(PRE) ocf $(POST)
#nopromptgo:	$(PRE) rcf $(POST)
#menugo:		$(PRE) mcf $(POST)
#xgo:		$(PRE) xcf $(POST)

ogo: obsolete_target
oldgo: obsolete_target
nopromptgo: obsolete_target
menugo: obsolete_target
xgo: obsolete_target
obsolete_target:
	@echo "The targets ogo, oldgo, menugo, nopromptgo and xgo are obsolete. Please read INSTALL"

# preliminaries
precheck:
	@if test ! -d $(KERNELSRC) -a ! -L $(KERNELSRC) ; \
	then \
		echo '*** cannot find directory "$(KERNELSRC)"!!' ; \
		echo '*** may be necessary to add symlink to kernel source' ; \
		exit 1 ; \
	fi
	@if ! cd $(KERNELSRC) ; \
	then \
		echo '*** cannot "cd $(KERNELSRC)"!!' ; \
		echo '*** may be necessary to add symlink to kernel source' ; \
		exit 1 ; \
	fi
	@if test ! -f $(KCFILE) ; \
	then \
		echo '*** cannot find "$(KCFILE)"!!' ; \
		echo '*** perhaps kernel has never been configured?' ; \
		echo '*** please do that first; the results are necessary.' ; \
		exit 1 ; \
	fi
	@if test ! -f $(VERFILE) ; \
	then \
		echo '*** cannot find "$(VERFILE)"!!' ; \
		echo '*** perhaps kernel has never been compiled?' ; \
		echo '*** please do that first; the results are necessary.' ; \
		exit 1 ; \
	fi

Makefile: Makefile.ver

# configuring (exit statuses disregarded, something fishy here sometimes)
xcf:
	-cd $(KERNELSRC) ; $(MAKE) $(KERNMAKEOPTS) xconfig
mcf:
	-cd $(KERNELSRC) ; $(MAKE) $(KERNMAKEOPTS) menuconfig
pcf:
	-cd $(KERNELSRC) ; $(MAKE) $(KERNMAKEOPTS) config

ocf:
	-cd $(KERNELSRC) ; $(MAKE) $(KERNMAKEOPTS) oldconfig 

rcf:
	cd $(KERNELSRC) ; $(MAKE) $(KERNMAKEOPTS) ${NONINTCONFIG} </dev/null
	cd $(KERNELSRC) ; $(MAKE) $(KERNMAKEOPTS) dep >/dev/null

kclean:
	-cd $(KERNELSRC) ; $(MAKE) $(KERNMAKEOPTS) clean

confcheck:
	@if test ! -f $(KCFILE) ; \
	then echo '*** no kernel configuration file written!!' ; exit 1 ; \
	fi
	@if ! egrep -q '^CONFIG_KLIPS=[my]' $(KCFILE) ; \
	then echo '*** IPsec not in kernel config ($(KCFILE))!!' ; exit 1 ; \
	fi
	@if ! egrep -q 'CONFIG_KLIPS[ 	]+1' $(ACFILE) && \
		! egrep -q 'CONFIG_KLIPS_MODULE[ 	]+1' $(ACFILE) ; \
	then echo '*** IPsec in kernel config ($(KCFILE)),' ; \
		echo '***	but not in config header file ($(ACFILE))!!' ; \
		exit 1 ; \
	fi
	@if egrep -q '^CONFIG_KLIPS=m' $(KCFILE) && \
		! egrep -q '^CONFIG_MODULES=y' $(KCFILE) ; \
	then echo '*** IPsec configured as module in kernel with no module support!!' ; exit 1 ; \
	fi
	@if ! egrep -q 'CONFIG_KLIPS_AH[ 	]+1' $(ACFILE) && \
		! egrep -q 'CONFIG_KLIPS_ESP[ 	]+1' $(ACFILE) ; \
	then echo '*** IPsec configuration must include AH or ESP!!' ; exit 1 ; \
	fi

# kernel building, with error checks
kernel:
	rm -f out.kbuild out.kinstall
	# undocumented kernel folklore: clean BEFORE dep. 
	# we run make dep seperately, because there is no point in running ERRCHECK
	# on the make dep output.
	# see LKML thread "clean before or after dep?"
	( cd $(KERNELSRC) ; $(MAKE) $(KERNMAKEOPTS) $(KERNCLEAN) $(KERNDEP) )
	( cd $(KERNELSRC) ; $(MAKE) $(KERNMAKEOPTS) $(KERNEL) ) 2>&1 | tee out.kbuild
	@if egrep -q '^CONFIG_MODULES=y' $(KCFILE) ; \
	then set -x ; \
		( cd $(KERNELSRC) ; \
		$(MAKE) $(KERNMAKEOPTS) modules 2>&1 ) | tee -a out.kbuild ; \
	fi
	${ERRCHECK} out.kbuild

# this target takes a kernel source tree and it builds a link tree,
# and then does make oldconfig for each .config file that was found in configs.
# The location for the disk space required for the link tree is found via
# $RH_KERNELSRC_POOL
preprhkern4module:
	if [ -z "${RH_KERNELSRC_POOL}" ]; then echo Please set RH_KERNELSRC_POOL.; exit 1; fi
	mkdir -p ${RH_KERNELSRC_POOL}
	KV=`${KVUTIL} $(RH_KERNELSRC)/Makefile` ; \
	cd ${RH_KERNELSRC_POOL} && \
	mkdir -p $$KV && cd $$KV && \
	for config in ${RH_KERNELSRC}/configs/*; do \
		basecfg=`basename $$config` ;\
		mkdir -p ${RH_KERNELSRC_POOL}/$$KV/$$basecfg && \
		cd ${RH_KERNELSRC_POOL}/$$KV/$$basecfg && \
		lndir ${RH_KERNELSRC} . && \
		rm -rf include/asm && \
		(cd include/linux && sed -e '/#include "\/boot\/kernel.h"/d' <rhconfig.h >rhconfig.h-new && mv rhconfig.h-new rhconfig.h ) && \
		rm -f include/linux/modules/*.stamp && \
		${MAKE} dep && \
		${MAKE} oldconfig; \
	done;

# module-only building, with error checks
ifneq ($(strip $(MODBUILDDIR)),)

=== lib/Makefile ===
# Makefile for the KLIPS interface utilities
# Copyright (C) 1998, 1999  Henry Spencer.
# Copyright (C) 1999, 2000, 2001  Richard Guy Briggs
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

OPENSWANSRCDIR?=$(shell cd ..; pwd)
include ${OPENSWANSRCDIR}/Makefile.inc

srcdir?=$(shell pwd)/

SUBDIRS=libopenswan libpluto libcrypto libwhack libipsecconf

ifeq ($(USE_LWRES),true)
SUBDIRS+=libisc libdns liblwres
endif

ifeq ($(USE_IPSECPOLICY),true)
SUBDIRS+=libipsecpolicy
endif

ifeq ($(USE_BSDKAME),true)
SUBDIRS+=libbsdpfkey
endif

def:
	@echo "Please read doc/intro.html or INSTALL before running make"
	@false

# programs

cleanall distclean mostlyclean realclean install programs checkprograms check clean spotless install_file_list:
	@for d in $(SUBDIRS) ; \
	do \
		(cd $$d && $(MAKE) srcdir=${srcdir}$$d/ OPENSWANSRCDIR=$(OPENSWANSRCDIR) $@ ) || exit 1;\
	done;

=== linux/Makefile ===
# FreeS/WAN subdir makefile
# Copyright (C) 1998-2001  Henry Spencer.
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

OPENSWANSRCDIR?=$(shell cd .. && pwd)
#SUBDIRS=net/ipsec

include $(OPENSWANSRCDIR)/Makefile.inc

def:
	@echo "Please read doc/intro.html or INSTALL before running make"
	@false

cleanall distclean mostlyclean realclean install programs checkprograms check clean spotless modules install_file_list:
	@true

#	@for d in $(SUBDIRS); \
#	do \
#		(cd $$d && $(MAKE) TOPDIR=${KERNELSRC} OPENSWANSRCDIR=$(OPENSWANSRCDIR)/.. $@ ) || exit 1 ; \
#	done

=== programs/Makefile ===
# Makefile for the KLIPS interface utilities
# Copyright (C) 1998, 1999  Henry Spencer.
# Copyright (C) 1999, 2000, 2001  Richard Guy Briggs
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

OPENSWANSRCDIR?=$(shell cd ..; pwd)
srcdir?=${OPENSWANSRCDIR}/programs/

include ${OPENSWANSRCDIR}/Makefile.inc

SUBDIRS=

ifeq ($(USE_LWRES),true)
SUBDIRS+=lwdnsq
endif

ifeq ($(USE_IPSECPOLICY),true)
SUBDIRS+=showpolicy
endif

SUBDIRS+=proc pluto addconn 
SUBDIRS+=_confread _copyright _include _keycensor _plutoload _plutorun
SUBDIRS+=_realsetup _secretcensor _updown 
SUBDIRS+=auto barf verify ipsec look newhostkey ranbits secrets
SUBDIRS+=rsasigkey setup showdefaults showhostkey 
SUBDIRS+=ikeping examples policy

ifeq ($(USE_KLIPS),true)
SUBDIRS+= _startklips _updown.klips 
SUBDIRS+=spi eroute spigrp tncfg klipsdebug pf_key
endif
ifeq ($(USE_MAST),true)
SUBDIRS+= _updown.mast 
endif
ifeq ($(USE_NETKEY),true)
SUBDIRS+= _startnetkey _updown.netkey
endif
ifeq ($(USE_BSDKAME),true)
SUBDIRS+=_realsetup.bsd _updown.bsdkame
endif


def:
	@echo "Please read doc/intro.html or INSTALL before running make"
	@false

# programs

cleanall distclean mostlyclean realclean install programs checkprograms clean spotless install_file_list:
	@for d in $(SUBDIRS) ; \
	do \
		(cd $$d && $(MAKE) srcdir=${srcdir}$$d/ OPENSWANSRCDIR=$(OPENSWANSRCDIR) $@ ) || exit 1;\
	done; \

check:
	@echo "info: all tests (check) are now in ../testing, doing nothing here."

=== testing/Makefile ===
# FreeS/WAN subdir makefile
# Copyright (C) 1998-2001  Henry Spencer.
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

OPENSWANSRCDIR?=$(shell cd ..; pwd)
include $(OPENSWANSRCDIR)/Makefile.inc

srcdir?=${OPENSWANSRCDIR}/testing/

SUBDIRS=lib utils 
SUBDIRS+=klips 
SUBDIRS+=pluto dnssec scripts packaging
#SUBDIRS+=umltree
#SUBDIRS+=kunit
# FIXUP: pfkey should NOT be commented out, but it needs debuging:
#SUBDIRS+=pfkey

def:
	@echo "Please read doc/intro.html or INSTALL before running make"
	@false

# programs

prerequisites cleanall distclean mostlyclean realclean install programs checkprograms check clean spotless install_file_list:
	@for d in $(SUBDIRS) ; \
	do \
		 ${MAKE} -C $$d srcdir=${srcdir}$$d/ OPENSWANSRCDIR=$(OPENSWANSRCDIR) $@ ;\
	done;

=== contrib/ldsaref/Makefile ===
OPENSWANSRCDIR=../..
-include ${OPENSWANSRCDIR}/Makefile.inc
CFLAGS += -I${OPENSWANSRCDIR}/include

SOURCE=saref.c
TARGET=libsaref.so

${TARGET}: ${SOURCE}
	$(CC) ${CFLAGS} -fPIC -o $@ -shared -ldl ${SOURCE}

.PHONY: clean
clean:
	rm -f *~ ${TARGET}

=== lib/libcrypto/Makefile ===
# Makefile for pluto/userspace crypto libraries
# Copyright (C) 2005 Michael Richardson <mcr@xelerance.com>
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.

OPENSWANSRCDIR?=$(shell cd ../..; pwd)
srcdir?=$(shell pwd)/
include ${OPENSWANSRCDIR}/Makefile.inc

SUBDIRS=libaes libdes libmd5 libsha1 libsha2 libmd2

ifeq ($(USE_EXTRACRYPTO),true)
SUBDIRS+=libblowfish libtwofish libserpent
endif

SUBDIRS+=liboswcrypto

def:
	@echo "Please read doc/intro.html or INSTALL before running make"
	@false

# programs

cleanall distclean mostlyclean realclean install programs checkprograms check clean spotless install_file_list:
	@for d in $(SUBDIRS) ; \
	do \
		(cd $$d && $(MAKE) srcdir=${srcdir}$$d/ OPENSWANSRCDIR=$(OPENSWANSRCDIR) $@ ) || exit 1; \
	done; \

=== lib/libdns/Makefile ===
# Copyright (C) 2000, 2001  Internet Software Consortium.
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM
# DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL
# INTERNET SOFTWARE CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT,
# INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
# FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
# WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

# $Id: Makefile,v 1.4 2005/09/17 21:57:45 mcr Exp $

OPENSWANSRCDIR?=$(shell cd ../..; pwd)
include ${OPENSWANSRCDIR}/Makefile.inc
srcdir?=./

HOSTCINCLUDES =	-I${srcdir}${ISCHOSTARCH}/include \
		-I${srcdir}../libisc/${ISCHOSTARCH}/include \
		-I${srcdir}../libisc/nothreads/include \
		-I. -I./include -I${srcdir}include \
		-I${srcdir}../libisc/include

CINCLUDES =	-I${srcdir}${ISCARCH}/include \
		-I${srcdir}../libisc/${ISCARCH}/include \
		-I${srcdir}../libisc/nothreads/include \
		-I. -I./include -I${srcdir}include \
		-I${srcdir}../libisc/include
CDEFINES = ${USERCOMPILE} ${PORTINCLUDE}
CWARNINGS = -Werror

CFLAGS+=${CINCLUDES} ${CDEFINES} ${CWARNINGS}

VERSION="@(\#) openswan-hacking-9.3-for-osw2"
LIBINTERFACE=2
LIBREVISION=0
LIBAGE=1
LIB=libdns
HDRS=include/dns/enumtype.h include/dns/enumclass.h include/dns/rdatastruct.h code.h

# Alphabetically
OBJS =		name.o rdata.o compress.o result.o ttl.o rcode.o
OBJS +=         time.o key.o lib.o

# Alphabetically
SRCS =		name.c rdata.c compress.c result.c ttl.c rcode.c
SRCS +=         time.c key.c lib.c

programs all: ${LIB}.a

version.o: version.c
	${LIBTOOL} --mode=compile ${CC} ${ALL_CFLAGS} \
		-DVERSION=\"${VERSION}\" \
		-DLIBINTERFACE=${LIBINTERFACE} \
		-DLIBREVISION=${LIBREVISION} \
		-DLIBAGE=${LIBAGE} \
		${CINCLUDES} ${CDEFINES} ${CWARNINGS} \
		-c ${srcdir}/version.c

${LIB}.a: ${OBJS} version.o
	${AR} ${ARFLAGS} $@ ${OBJS} version.o

timestamp: ${LIB}.a
	touch timestamp

clean distclean mostlyclean realclean cleanall spotless::
	rm -f ${LIB}.a ${LIB}.la timestamp $(OBJS) version.o ${HDRS} gen

install checkprograms check install_file_list:
	@true

TAGS: ${SRCS}
	etags ${SRCS}

rdata.o: code.h 
name.o: ${HDRS}

include/dns/enumtype.h: gen
	mkdir -p include/dns
	./gen -s ${srcdir} -t > $@

include/dns/enumclass.h: gen
	mkdir -p include/dns
	./gen -s ${srcdir} -c > $@

include/dns/rdatastruct.h: gen \
		${srcdir}rdata/rdatastructpre.h \
		${srcdir}rdata/rdatastructsuf.h
	mkdir -p include/dns
	./gen -s ${srcdir} -i \
		-P ${srcdir}rdata/rdatastructpre.h \
		-S ${srcdir}rdata/rdatastructsuf.h > $@

code.h:	gen
	./gen -s ${srcdir} > code.h

# this program is to be built on the host, and should not be
# cross-compiled!
HOSTCC?=cc
gen: gen.c
	${HOSTCC} ${HOSTCINCLUDES} ${LDFLAGS} -o $@ ${srcdir}gen.c ${LIBS}

=== lib/libipsecconf/Makefile ===
# Openswan library for parsing configuration files
# Copyright (C) 2005 Michael Richardson <mcr@xelerance.com> Xelerance Corporation
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.


OPENSWANSRCDIR?=$(shell cd ../..; pwd)

include ${OPENSWANSRCDIR}/Makefile.inc
include ${OPENSWANSRCDIR}/Makefile.ver

LIBRARY=ipsecconf
LIB=lib${LIBRARY}.a
MANDIR=$(MANTREE)/man3

ONEFILE=parser.y
SRCS=confread.c confwrite.c starterwhack.c starterlog.c 
SRCS+=cmp.c parser.tab.c lex.yy.c keywords.c alloc.c oeconns.c
SRCS+=interfaces.c

#enable to get lots more debugging about semantics.
#CFLAGS+=-DPARSER_TYPE_DEBUG

#ifeq ($(USE_FIPSCHECK),true)
#CFLAGS+=-DFIPS_CHECK
ifeq ($(USE_LIBNSS),true)
CFLAGS+=-DHAVE_LIBNSS
CFLAGS+=-I/usr/include/nspr4 -I/usr/include/nss3
endif

ifeq ($(USE_NM),true)
CFLAGS+=-DHAVE_NM
endif

ifeq ($(USE_LABELED_IPSEC),true)
CFLAGS+=-DHAVE_LABELED_IPSEC
endif

ifeq ($(USE_KLIPS),true)
SRCS+=virtif.c
endif

OBJS=${SRCS:.c=.o} 

include ${srcdir}../Makefile.library

keywords.c: parser.tab.h

lex.yy.c: parser.tab.c parser.l parser.y 
	$(LEX) ${srcdir}parser.l

parser.tab.h parser.tab.c: parser.l parser.y 
	$(BISON) ${BISONOSFLAGS} -v -d ${srcdir}parser.y

cleanall::
	$(RM) -f parser.tab.* lex.yy.*

=== lib/libipsecpolicy/Makefile ===
# FreeS/WAN library
# Copyright (C) 2003	Michael Richardson	<mcr@freeswan.org>
# 
# This program is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 2 of the License, or (at your
# option) any later version.  See <http://www.fsf.org/copyleft/gpl.txt>.
# 
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
# or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
# for more details.


OPENSWANSRCDIR?=$(shell cd ../..; pwd)

include ${OPENSWANSRCDIR}/Makefile.inc
include ${OPENSWANSRCDIR}/Makefile.ver


MANDIR=$(MANTREE)/man3

SRCS=policyquery.c cgipolicy.c

OBJS=${SRCS:.c=.o} version.o

KLIPSD=${OPENSWANSRCDIR}/linux/include

LIB=libipsecpolicy.a
# Original flags
CFLAGS+=-I. -I${KLIPSD} -I${OPENSWANSRCDIR} -I${OPENSWANSRCDIR}/include $(USERCOMPILE) ${PORTINCLUDE}
CFLAGS+= -Wall
CFLAGS+= -Wpointer-arith
CFLAGS+= -Wcast-qual
CFLAGS+= -Wstrict-prototypes
CFLAGS+= -Wbad-function-cast 

MANS=

.PHONY:	all install clean l t lt tar check depend checkprograms

# we can't do tests with two conditions, but we can concatenate the strings
SHOULDWERESTART=${USE_OBJDIR}$(wildcard policyquery.c)
ifeq ($(SHOULDWERESTART),truepolicyquery.c)
all programs clean install:
	cd ${OPENSWANSRCDIR} && cd ${OBJDIRTOP}/lib/libipsecpolicy && make $@
else
all:	$(LIB) 
programs: $(LIB) 
clean:	cleanall
install: doinstall

endif

doinstall:
	@mkdir -p $(MANDIR)
	@for f in $(MANS) ; \
	do \
		$(INSTALL) $(INSTMANFLAGS) $(SRCDIR)/$$f $(MANDIR)/ipsec_$$f || exit 1 ; \
	done
	@$(OPENSWANSRCDIR)/packaging/utils/manlink $(foreach man, $(MANS), ${SRCDIR}/$(man)) | \
	while read from to; \
	do \
		ln -s -f ipsec_$$from $(MANDIR)/$$to; \
	done


install_file_list:
	@for f in $(MANS) ; \
	do \
		echo $(MANDIR)/ipsec_$$f;\
	done;
	@$(OPENSWANSRCDIR)/packaging/utils/manlink $(foreach man, $(MANS), ${SRCDIR}/$(man)) | \
	while read from to; \
	do \
		echo $(MANDIR)/$$to; \
	done

$(LIB):	$(OBJS)
	$(AR) $(ARFLAGS) $(LIB) $(OBJS)

$(OBJS):	$(HDRS)

# build version.c using version number from Makefile.ver
version.c:	version.in.c ${OPENSWANSRCDIR}/Makefile.ver
	sed '/"/s/@IPSECVERSION@/$(IPSECVERSION)/' ${KLIPSSRCDIR}/version.in.c >$@

cleanall:
	rm -f $(LIB) *.o try* core *.core $(EXTHDRS) $(EXTLIBS) version.c


#tar:	clean
#	tar -cvf /tmp/lib.tar Makefile [a-z]*

check:
	echo no checks in lib right now.

depend:
	makedepend -Y -- $(CFLAGS) -- $(SRCS)

checkprograms:

# DO NOT DELETE

=== lib/libisc/Makefile ===
# Copyright (C) 2000, 2001  Internet Software Consortium.
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM
# DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL
# INTERNET SOFTWARE CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT,
# INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
# FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
# WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

# $Id: Makefile,v 1.3 2005/09/17 21:57:45 mcr Exp $

OPENSWANSRCDIR?=$(shell cd ../..; pwd)
include ${OPENSWANSRCDIR}/Makefile.inc

CINCLUDES =	-I${srcdir}${ISCARCH}/include \
		-I${srcdir}nothreads/include \
		-I. -I./include -I${srcdir}include \
		$(PORTINCLUDE) -I${OPENSWANSRCDIR}/include
CDEFINES = -DHAVE_STRERROR ${USERCOMPILE} ${PORTINCLUDE}
# CWARNINGS = -Werror

CFLAGS+=${CINCLUDES} ${CDEFINES} ${CWARNINGS}

VERSION="@(\#) openswan-hacking-9.3-for-osw2"
LIBINTERFACE=2
LIBREVISION=0
LIBAGE=1
LIB=libisc
VPATH+=${srcdir}nls 
VPATH+=${srcdir}${ISCARCH}

OBJS =		mem.o buffer.o inet_pton.o assertions.o error.o 
OBJS += 	lib.o region.o lex.o hex.o string.o result.o base64.o
OBJS += 	msgcat.o parseint.o stdio.o stdtime.o ondestroy.o
OBJS += 	task.o event.o errno2result.o strerror.o 
OBJS +=		rwlock.o random.o inet_aton.o inet_ntop.o

SRCS =		mem.c buffer.c inet_pton.c assertions.c error.c 
SRCS += 	lib.c region.c lex.c hex.c string.c result.c base64.c
SRCS +=		msgcat.c parseint.c stdio.c stdtime.c ondestroy.c
SRCS +=		task.c event.c errno2result.c strerror.c 
SRCS +=		rwlock.c random.c inet_aton.c inet_ntop.c

programs all: ${LIB}.a

version.o: version.c
	${LIBTOOL} --mode=compile ${CC} ${ALL_CFLAGS} \
		-DVERSION=\"${VERSION}\" \
		-DLIBINTERFACE=${LIBINTERFACE} \
		-DLIBREVISION=${LIBREVISION} \
		-DLIBAGE=${LIBAGE} \
		${CINCLUDES} ${CDEFINES} ${CWARNINGS} \
		-c ${srcdir}version.c

${LIB}.a: ${OBJS} version.o
	${AR} ${ARFLAGS} $@ ${OBJS} version.o

timestamp: ${LIB}.a
	touch timestamp

clean distclean mostlyclean realclean cleanall spotless::
	rm -f ${LIB}.a ${LIB}.la timestamp $(OBJS) version.o

install checkprograms check install_file_list:
	@true

TAGS: ${SRCS}
	etags ${SRCS}

=== lib/liblwres/Makefile ===
# Copyright (C) 2000, 2001  Internet Software Consortium.
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND INTERNET SOFTWARE CONSORTIUM
# DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL
# INTERNET SOFTWARE CONSORTIUM BE LIABLE FOR ANY SPECIAL, DIRECT,
# INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING
# FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT,
# NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION
# WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

# $Id: Makefile,v 1.11 2005/09/17 21:57:45 mcr Exp $

OPENSWANSRCDIR?=$(shell cd ../..; pwd)
include ${OPENSWANSRCDIR}/Makefile.inc

CINCLUDES =	-I${srcdir}${ISCARCH}/include \
		-I${srcdir}../libisc/${ISCARCH}/include \
		-I${srcdir}../libisc/include \
		-I. -I./include -I${srcdir}include 
CDEFINES =
CWARNINGS = -Werror

CFLAGS+=${USERCOMPILE} ${PORTINCLUDE} ${CINCLUDES} ${CDEFINES} ${CWARNINGS} 

VERSION="@(\#) openswan-hacking-9.3-for-osw2"
LIBINTERFACE=2
LIBREVISION=0
LIBAGE=1

# Alphabetically
OBJS =		async.o context.o gai_strerror.o getaddrinfo.o gethost.o \
		getipnode.o getnameinfo.o getrrset.o getrrset2.o herror.o \
		lwbuffer.o lwconfig.o lwpacket.o lwresutil.o \
		lwres_gabn.o lwres_gnba.o lwres_grbn.o lwres_noop.o \
		lwinetaton.o lwinetpton.o lwinetntop.o version.o

# Alphabetically
SRCS =		async.c context.c gai_strerror.c getaddrinfo.c gethost.c \
		getipnode.c getnameinfo.c getrrset.c getrrset2.c herror.c \
		lwbuffer.c lwconfig.c lwpacket.c lwresutil.c \
		lwres_gabn.c lwres_gnba.c lwres_grbn.c lwres_noop.c \
		lwinetaton.c lwinetpton.c lwinetntop.c

LIB=liblwres.a
LIBRARY=lwres
ONEFILE=async.c

.PHONY:	all install clean l t lt tar check depend checkprograms

all: programs

version.o: version.c
	${LIBTOOL} --mode=compile ${CC} ${CFLAGS} \
		-DVERSION=\"${VERSION}\" \
		-DLIBINTERFACE=${LIBINTERFACE} \
		-DLIBREVISION=${LIBREVISION} \
		-DLIBAGE=${LIBAGE} \
		${CINCLUDES} ${CDEFINES} ${CWARNINGS} \
		-c ${srcdir}version.c

timestamp: liblwres.a
	touch timestamp

$(OBJS):	$(HDRS)

check:
	echo no checks in lib right now.

checkprograms:
	@true

include ${srcdir}../Makefile.library

=== debian/changelog ===
openswan (1:2.6.38-1) unstable; urgency=low

  [Harald Jenny]
  * New upstream release.
  * Removed format security patch by Moritz Muehlenhoff (applied upstream).
  * Added patch from upstream git to fix mast updown script.
  * Bumped Standards for all packages to 3.9.3 (no changes needed).
  * Added patch from upstream git to fix Android interoperability.
  * Added patch from upstream git to fix Cisco interoperability.
  * Added patch from upstream git to allow timestamps in stderr log.
  * Added patch from upstream git to fix some coding issues.
  * Added patch from upstream git to fix possible IKEv2 crash.
  * Added patch from upstream git to fix IPSec transport mode.
  * Added patch from upstream git to use ip route in startklips.

 -- Harald Jenny <harald@a-little-linux-box.at>  Fri, 29 Jun 2012 21:23:28 +0200

openswan (1:2.6.37-3) unstable; urgency=low

  * Actually need to pass CPPFLAGS to CFLAGS for the openswan Makefiles
    to use the hardening options. Thanks to Simon Ruderich for pointing
    this out. 
    Really Closes: #655139
  * Remove Build-Deps on man2html and htmldoc, they have not been used
    for a while now by the openswan Makefiles.

 -- Rene Mayrhofer <rmayr@debian.org>  Sun, 27 May 2012 10:03:00 +0200

openswan (1:2.6.37-2) unstable; urgency=low

  [Harald Jenny]
  * Finally migrated all patches to quilt, cleaned up debian rules file a
    little bit, removed build depedency on dpatch and corresponding lintian
    override.
  * Integrated patches for hardening build flags and missing format strings
    (thanks to Moritz Muehlenhoff for his patches), added required versioned
    build depedency on dpkg-dev and enabled all hardening options.
    Closes: #655139: Please enabled hardened build flags

 -- Harald Jenny <harald@a-little-linux-box.at>  Mon, 14 May 2012 22:22:55 +0200

openswan (1:2.6.37-1.1) unstable; urgency=low

  * Non-maintainer upload.
  * Fix pending l10n issues. Debconf translations:
    - Turkish (Atila KOÇ).  Closes: #660192
    - Danish (Joe Hansen).  Closes: #660263
    - Italian (Beatrice Torracca).  Closes: #660758
    - Polish (Michał Kułach).  Closes: #669711

 -- Christian Perrier <bubulle@debian.org>  Sat, 28 Apr 2012 07:17:18 +0200

=== debian/control ===
Source: openswan
Section: net
Priority: optional
Maintainer: Rene Mayrhofer <rmayr@debian.org>
Uploaders: Harald Jenny <harald@a-little-linux-box.at>
Standards-Version: 3.9.3
Vcs-Browser: http://git.debian.org/?p=pkg-swan/openswan.git;a=summary
Vcs-Git: git://git.debian.org/git/pkg-swan/openswan.git
Build-Depends: dpkg-dev (>= 1.16.1~), debhelper (>= 7.1), libgmp3-dev, libssl-dev (>= 0.9.8), libcurl4-openssl-dev, libldap2-dev, libpam0g-dev, libkrb5-dev, bison, flex, bzip2, po-debconf
Homepage: http://www.openswan.org/

Package: openswan
Architecture: linux-any
Pre-Depends: debconf | debconf-2.0
Depends: ${shlibs:Depends}, ${misc:Depends}, bsdmainutils, openssl, host, iproute, iproute (>=20041019-0.1) | ipsec-tools
Suggests: openswan-modules-source | openswan-modules-dkms, openswan-doc, curl
Provides: ike-server
Conflicts: ike-server
Replaces: ike-server
Description: Internet Key Exchange daemon
 Openswan is an IPsec based VPN solution for the Linux kernel. It can use the
 native IPsec stack as well as the KLIPS kernel module. Both IKEv1 and IKEv2
 protocols are supported.
 .
 The Openswan IKE daemon is named pluto. It was inherited from the FreeS/WAN
 project, but provides improved X.509 certificate support and other features.
 .
 In order to use the KLIPS IPsec code instead of the native version, you will
 need to either install openswan-modules-source and build the appropriate
 module for your kernel or use openswan-modules-dkms which automates this
 task.

Package: openswan-dbg
Architecture: linux-any
Section: debug
Priority: extra
Depends: ${misc:Depends}, openswan (= ${binary:Version})
Description: Internet Key Exchange daemon - debugging symbols
 Openswan is an IPsec based VPN solution for the Linux kernel. It can use the
 native IPsec stack as well as the KLIPS kernel module. Both IKEv1 and IKEv2
 protocols are supported.
 .
 This package provides the symbols needed for debugging of openswan
 binaries.

Package: openswan-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Description: Internet Key Exchange daemon - documentation
 Openswan is an IPsec based VPN solution for the Linux kernel. It can use the
 native IPsec stack as well as the KLIPS kernel module. Both IKEv1 and IKEv2
 protocols are supported.
 .
 This package provides the free parts of the documentation for Openswan.

Package: openswan-modules-source
Architecture: all
Section: kernel
Depends: ${misc:Depends}, debhelper, bzip2
Recommends: module-assistant | kernel-package, linux-headers | linux-source
Suggests: openswan
Description: Internet Key Exchange daemon - kernel module source
 Openswan is an IPsec based VPN solution for the Linux kernel. It can use the
 native IPsec stack as well as the KLIPS kernel module. Both IKEv1 and IKEv2
 protocols are supported.
 .
 For support of the old-style KLIPS ipsecX network interfaces a custom
 kernel module is needed.
 .
 This package contains source code for the Openswan IPsec kernel module,
 which can be used with tools like module-assistant or kernel-package
 for manual building of local kernel images.
 .
 Kernel versions >= 2.6.23 no longer need to be patched to provide NAT
 Traversal support for KLIPS.

Package: openswan-modules-dkms
Architecture: linux-any
Section: kernel
Depends: ${misc:Depends}, dkms, openswan
Description: Internet Key Exchange daemon - DKMS source
 Openswan is an IPsec based VPN solution for the Linux kernel. It can use the
 native IPsec stack as well as the KLIPS kernel module. Both IKEv1 and IKEv2
 protocols are supported.
 .
 For support of the old-style KLIPS ipsecX network interfaces a custom
 kernel module is needed.
 .
 This package contains source code for the Openswan IPsec kernel module,
 which can be used with DKMS so that local kernel images are automatically
 built and installed every time relevant kernel packages are upgraded.
 .
 Kernel versions >= 2.6.23 no longer need to be patched to provide NAT
 Traversal support for KLIPS.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DH_OPTIONS

export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
DEB_CFLAGS_MAINT_APPEND=-fno-strict-aliasing
DEB_CXXFLAGS_MAINT_APPEND=-fno-strict-aliasing
include /usr/share/dpkg/buildflags.mk

# The build system doesn't respect CPPFLAGS, pass them to CFLAGS/CXXFLAGS to
# enable the missing (hardening) flags.
CFLAGS   += $(CPPFLAGS)
CXXFLAGS += $(CPPFLAGS)

build-arch: build
build-indep: build
build: build-stamp
build-stamp:
	# create a dummy ipsec.secrets file before building the package so
	# that no RSA keys are created during the build process
	# (a package should not include a RSA key, it should produce the key
	# on demand, e.g. in the postinst script)
	touch $(CURDIR)/debian/ipsec.secrets
	$(MAKE) programs INC_USRLOCAL=/usr \
			 FINALBINDIR=/usr/lib/ipsec \
			 FINALLIBEXECDIR=/usr/lib/ipsec \
			 PUBDIR=/usr/sbin \
			 MANTREE=/usr/share/man \
			 CONFDIR=$(CURDIR)/debian \
			 USE_LDAP=true USE_LIBCURL=true \
			 USE_XAUTHPAM=true
	# remove the temporary file, it will be created during install
	rm -f $(CURDIR)/debian/ipsec.secrets

	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp

	[ ! -f Makefile ] || $(MAKE) clean

	# after a make clean, no binaries _should_ be left, but ....
	-find $(CURDIR) -name "*.o" | xargs --no-run-if-empty rm
	-find $(CURDIR)/lib/libcrypto -name "*.a" | xargs --no-run-if-empty rm

	rm -rf debian/openswan-modules-source-build/

	# Really clean (#356716)
	# This is a hack: should be better implemented
	rm -f lib/libopenswan/libopenswan.a || true
	rm -f lib/libopenswan/liboswlog.a || true
	rm -rf OBJ.* || true

	# just in case something went wrong
	rm -f $(CURDIR)/debian/ipsec.secrets

	# and make sure that template are up-to-date
	debconf-updatepo

	dh_clean

install-openswan: DH_OPTIONS=-a
install-openswan: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	# Add here commands to install the package into debian/tmp.
	$(MAKE) install INC_USRLOCAL=/usr \
			FINALBINDIR=/usr/lib/ipsec \
			FINALLIBEXECDIR=/usr/lib/ipsec \
			PUBDIR=$(CURDIR)/debian/openswan/usr/sbin \
			MANTREE=$(CURDIR)/debian/openswan/usr/share/man \
			DESTDIR=$(CURDIR)/debian/openswan
	rm -rf $(CURDIR)/debian/openswan/usr/local
	install --mode=0600 $(CURDIR)/debian/ipsec.secrets.proto $(CURDIR)/debian/openswan/etc/ipsec.secrets

	rm -f $(CURDIR)/debian/openswan/etc/init.d/ipsec?*
	rm -f $(CURDIR)/debian/openswan/usr/lib/ipsec/_plutorun?*

	# this is handled by update-rc.d
	rm -rf $(CURDIR)/debian/openswan/etc/rc?.d

	# delete var/lock/subsys and var/run to satisfy lintian
	rm -rf $(CURDIR)/debian/openswan/var/lock
	rm -rf $(CURDIR)/debian/openswan/var/run

	# remove the already installed docs
	rm -rf "$(CURDIR)/debian/openswan/usr/share/doc"

	# fix some manpage issues
	for oldname in `find $(CURDIR)/debian/openswan/usr/share/man -name "ipsec_ipsec*"`; \
	do \
	    newname=`echo "$$oldname" | sed 's/ipsec_ipsec_/ipsec_/'`; \
	    if [ -f "$$newname" ]; then \
		rm -f "$$oldname"; \
	    else \
		mv "$$oldname" "$$newname"; \
	    fi; \
	done

	dh_installdocs -popenswan -n
	dh_installchangelogs CHANGES

	# openswan-dbg depends on openswan so no need to ship doc twice
	rm -rf $(CURDIR)/debian/openswan-dbg/usr/share/doc/openswan-dbg

	# the logcheck ignore files
	install -D --mode=0600 $(CURDIR)/debian/logcheck.ignore.paranoid $(CURDIR)/debian/openswan/etc/logcheck/ignore.d.paranoid/openswan
	install -D --mode=0600 $(CURDIR)/debian/logcheck.ignore.server $(CURDIR)/debian/openswan/etc/logcheck/ignore.d.server/openswan
	install -D --mode=0600 $(CURDIR)/debian/logcheck.ignore.server $(CURDIR)/debian/openswan/etc/logcheck/ignore.d.workstation/openswan
	install -D --mode=0600 $(CURDIR)/debian/logcheck.violations.ignore $(CURDIR)/debian/openswan/etc/logcheck/violations.ignore.d/openswan

	# set permissions on ipsec.secrets
	chmod 600 $(CURDIR)/debian/openswan/etc/ipsec.secrets
	chmod 644 $(CURDIR)/debian/openswan/etc/ipsec.conf
	chmod 700 -R $(CURDIR)/debian/openswan/etc/ipsec.d/private/
	# don't know why they come with +x set by default...
	chmod 644 $(CURDIR)/debian/openswan/etc/ipsec.d/policies/*
	chmod 644 $(CURDIR)/debian/openswan/etc/ipsec.d/examples/*

	# create /var/lib/openswan with permissions similar to ipsec.secrets
	mkdir -p $(CURDIR)/debian/openswan/var/lib/openswan
	chmod 700 -R $(CURDIR)/debian/openswan/var/lib/openswan

	# more lintian cleanups
	find $(CURDIR)/debian/openswan -name ".gitignore" | xargs --no-run-if-empty rm -f

	# Empty directory
	rmdir $(CURDIR)/debian/openswan/usr/bin

install-openswan-doc: DH_OPTIONS=-popenswan-doc
install-openswan-doc: build
	dh_testdir
	dh_testroot

	dh_installdocs -popenswan-doc -n
	dh_installchangelogs CHANGES

	# fix some doc issues
	for oldname in `find $(CURDIR)/debian/openswan-doc/usr/share/doc -name "ipsec_ipsec*"`; \
	do \
	    newname=`echo "$$oldname" | sed 's/ipsec_ipsec_/ipsec_/'`; \
	    if [ -f "$$newname" ]; then \
		rm -f "$$oldname"; \
	    else \
		mv "$$oldname" "$$newname"; \
	    fi; \
	done

	# change the paths in the installed doc files (but only in regular
	# files, not in links to the outside of the build tree !)
	( cd $(CURDIR)/debian/openswan-doc/; \
	  for f in `grep "/usr/local/" --recursive --files-with-match *`; \
	  do \
		if [ -f $$f -a ! -L $$f ]; then \
		    cp $$f $$f.old; \
		    sed 's/\/usr\/local\//\/usr\//' $$f.old > $$f; \
		    rm $$f.old; \
		fi; \
	  done )
	# but remove the doc/src dir, which just duplicates the HTML files
	rm -rf $(CURDIR)/debian/openswan-doc/usr/share/doc/openswan-doc/doc/src

	# more lintian cleanups
	find $(CURDIR)/debian/openswan-doc -name ".gitignore" | xargs --no-run-if-empty rm -f

install-openswan-modules-source: DH_OPTIONS=-popenswan-modules-source
install-openswan-modules-source: PKGDIR=$(CURDIR)/debian/openswan-modules-source
install-openswan-modules-source: BUILDDIR=$(CURDIR)/debian/openswan-modules-source-build
install-openswan-modules-source:
	dh_testdir
	dh_testroot
	dh_installdirs
	mkdir -p "$(BUILDDIR)/modules/openswan"
	mkdir -p "$(BUILDDIR)/modules/openswan/lib"
	mkdir -p "$(BUILDDIR)/modules/openswan/debian"
	mkdir -p "$(BUILDDIR)/modules/openswan/packaging"
	mkdir -p "$(BUILDDIR)/modules/openswan/patches/kernel"
	cp -r CHANGES CREDITS Makefile Makefile.top Makefile.inc Makefile.ver linux/ \
		"$(BUILDDIR)/modules/openswan"
	cp -r lib/libcrypto "$(BUILDDIR)/modules/openswan/lib/"
	cp -r packaging/makefiles packaging/linus packaging/utils packaging/defaults/ \
		"$(BUILDDIR)/modules/openswan/packaging/"
	cp -r patches/kernel/2.6.32 "$(BUILDDIR)/modules/openswan/patches/kernel/"
	cp -r patches/kernel/2.6.35 "$(BUILDDIR)/modules/openswan/patches/kernel/"
	find "$(BUILDDIR)/modules/openswan/lib/" -name "*.o" | xargs --no-run-if-empty rm
	install --mode=644 debian/openswan-modules-source.kernel-config "$(BUILDDIR)/modules/openswan/config-all.h"
	install --mode=755 debian/openswan-modules-source.rules "$(BUILDDIR)/modules/openswan/debian/rules"
	install --mode=644 debian/openswan-modules-source.control.in "$(BUILDDIR)/modules/openswan/debian/control.in"
	install --mode=644 debian/openswan-modules-source.docs "$(BUILDDIR)/modules/openswan/debian/docs.in"
	install --mode=644 debian/openswan-modules-source.lintian-overrides.in "$(BUILDDIR)/modules/openswan/debian/lintian-overrides.in"
	install --mode=644 debian/compat "$(BUILDDIR)/modules/openswan/debian/"
	install --mode=644 debian/changelog "$(BUILDDIR)/modules/openswan/debian/"
	install --mode=644 debian/copyright "$(BUILDDIR)/modules/openswan/debian/"
	install --mode=644 debian/NEWS "$(BUILDDIR)/modules/openswan/debian/"
	install --mode=644 debian/README.Debian "$(BUILDDIR)/modules/openswan/debian/"

	tar -C $(BUILDDIR) -c modules/ | bzip2 -9 > \
		"$(PKGDIR)/usr/src/openswan-modules.tar.bz2"

	dh_installdocs -popenswan-modules-source -n

=== debian/watch ===
version=3
opts=dversionmangle=s/\+dfsg\+?\d?$// \
http://www.openswan.org/download/openswan-([\d.]+)\.tar\.gz
